// ChoiceScreen.java
//Written by: Maria Kazandjieva, marykaz@hotmail.com, Summer 2005

// This is the main screen of the application.
// It allows the user to select the information to be displayed
// created 06/13/05


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.Rectangle.*;
import java.lang.*;


public class ChoiceScreen extends JFrame implements ActionListener {

	// declare and initialize variables

	Container c;
	JPanel textPanel, choicePanel, goPanel;
	Border raisedetched = BorderFactory.createEtchedBorder(EtchedBorder.RAISED);
	JButton goB;
	JCheckBox dataBox, energyBox, positionBox;
	JLabel label1;
	Node[] array;
	int numberNodes;

public ChoiceScreen () {

	// the constructor creates a frame that has three checkbox options
	// depending on what is selected, when the button is pressed, different frames open
	super ("Select an option");
	this.setLocation(325, 200);

	this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

	c = getContentPane();
	c.setLayout (new BorderLayout(5,5));

	label1 = new JLabel ("<html>Choose one or more data sets to view.<p>Use the check boxes to make your selection.</html>");

	textPanel = new JPanel();
	textPanel.add(label1);

	choicePanel = new JPanel();
	choicePanel.setLayout (new FlowLayout ());

	goPanel = new JPanel();

	dataBox = new JCheckBox("Data Records");
	energyBox = new JCheckBox ("Energy Records");
	positionBox = new JCheckBox ("Coordinates Info");

	choicePanel.add (dataBox);
	choicePanel.add (energyBox);
	choicePanel.add (positionBox);

	goB = new JButton ("Display data");
	goB.addActionListener(this);
	goPanel.add(goB);


	c.add(textPanel, BorderLayout.NORTH);
	c.add (choicePanel, BorderLayout.CENTER);
	c.add(goPanel, BorderLayout.SOUTH);

	//menu bar
	JMenuBar menu = new JMenuBar();
	setJMenuBar (menu);
	JMenu fileMenu = new JMenu("File");

	JMenuItem exit = new JMenuItem ("Exit");

	exit.addActionListener (new ActionListener() {
	public void actionPerformed (ActionEvent e)
	{
		System.exit(0);
	}
	}
	);
	fileMenu.add(exit);

	menu.add(fileMenu);

	setSize (400,200);
	setResizable(false);
	show();
	}


//the actionPerformed method is what triggers the display of different frames(windows)
// the series of if/else statements runs the appropriate visual display

public void actionPerformed (ActionEvent e) {

		boolean checkenergy = energyBox.isSelected();
		boolean checkData = dataBox.isSelected();
		boolean checkPosition = positionBox.isSelected();

		if (e.getSource() == goB && checkenergy ==true
			&& checkData == false && checkPosition==false) {
			this.setVisible(false);
			new Energy();
		}
		else if (e.getSource() == goB && checkenergy ==false
			&& checkData == true && checkPosition==false) {
			this.setVisible(false);
			new Data();
		}
		else if (e.getSource() == goB && checkenergy ==true
			&& checkData == true && checkPosition==false) {
			this.setVisible(false);
			new EnergyAndData();
		}
		else if (e.getSource() == goB && checkenergy ==false
			&& checkData == false && checkPosition==true) {
			this.setVisible(false);
			new Coordinates();
		}
		else if (e.getSource() == goB && checkenergy ==true
			&& checkData == false && checkPosition==true) {
			this.setVisible(false);
			new Location_Energy();
		}
		else if (e.getSource() == goB && checkenergy ==false
			&& checkData == true && checkPosition==true) {
			this.setVisible(false);
			new Location_Data();
		}
		else if (e.getSource() == goB && checkenergy ==true
			&& checkData == true && checkPosition==true) {
			this.setVisible(false);
			new AllThree();
		}
}

}
