// Data.java
//Written by: Maria Kazandjieva, marykaz@hotmail.com, Summer 2005

// Displays the data (temperature readings) collected by the nodes
// created 06/10/05


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.Rectangle.*;
import java.lang.*;
import java.util.Random;



public class Data extends JFrame
{
	//declare and initialize variables

	private int numberNodes = Global.numberNodes;
	private Node[] nodes_array = Global.nodes_array;
	Node myNode;

	private final int MAX=100;

	double[] data = new double [numberNodes];
	JCheckBox[] nodes;
	JLabel[] enegryL, visualL;
	Container c;
	JPanel infoPanel;
	JScrollPane scrollPane;
	Border raisedetched= BorderFactory.createEtchedBorder(EtchedBorder.RAISED);
	boolean[] toggle = new boolean[numberNodes];
	Icon[] bar;
	JMenuBar menu;

	public Data() {

	super ("Temperature data");
	this.setLocation(325, 200);		//specifiy location for mthe frame on the desktop

	c = getContentPane();			//create a content pane to hold all object
	c.setLayout (new FlowLayout());	//set its layout

	this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

	infoPanel = new JPanel();
	infoPanel.setLayout (new GridLayout (numberNodes, 3));
	infoPanel.setBorder(raisedetched);

	// initialize various arrays
	nodes = new JCheckBox[numberNodes];
	enegryL = new JLabel [numberNodes];
	bar = new Icon[numberNodes];
	visualL = new JLabel [numberNodes];

	CheckBoxHandler handler = new CheckBoxHandler();	//create ahandler forthe checkboxes

	//this part of the code generates random numbers to  initialize the boolean array
	//that keeps track of whether a node has been shown or hidden.

	Random rand = new Random();

	for (int j=0; j<numberNodes; j++){
		toggle[j] = true;
	}

	// in this loop we create the checkboes, and labels and position them accordigly.
	for (int i=0; i<numberNodes; i++) {
		myNode = nodes_array[i];

		nodes[i] = new JCheckBox ("Node " + (i+1), toggle[i]);
		infoPanel.add (nodes[i]);
		nodes[i].addItemListener(handler);

		bar[i] = new Bar((int)Math.ceil (myNode.getData()), 15, 0, 0, 255);
		visualL[i] = new JLabel ("");
		visualL[i].setIcon(bar[i]);
		visualL[i].setToolTipText("Temperature reading: " + myNode.getData());
		infoPanel.add(visualL[i]);

		enegryL[i] = new JLabel ("Temperature: " + myNode.getData());
		infoPanel.add (enegryL[i]);
	}

	//creating a scroll pane and adding the main panel to it will allow for
	// the display of unlimited number of records in a space-aware fashion
	scrollPane = new JScrollPane(infoPanel);
	scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
      scrollPane.setPreferredSize(new Dimension(410,360));

	c.add(scrollPane);

	// next, we create a menu bar that has several different options
	JMenuBar menu = new JMenuBar();
	setJMenuBar (menu);
	JMenu fileMenu = new JMenu("File");

	JMenuItem home = new JMenuItem("Selection screen");
	home.addActionListener (new ActionListener() {
	public void actionPerformed (ActionEvent e)
	{
		new ChoiceScreen();
		setVisible(false);
	}
	}
	);
	fileMenu.add(home);

	JMenuItem exit = new JMenuItem ("Exit");

	exit.addActionListener (new ActionListener() {
	public void actionPerformed (ActionEvent e)
	{
		System.exit(0);
	}
	}
	);
	fileMenu.add(exit);

	menu.add(fileMenu);
	JMenu optionsMenu = new JMenu ("Options");
	menu.add (optionsMenu);
	JMenuItem select = new JMenuItem ("Select all");
	optionsMenu.add(select);
	select.addActionListener (new ActionListener() {
		public void actionPerformed(ActionEvent e)
	{
		for (int i=0; i<numberNodes; i++)
		{
			enegryL[i].setVisible(true);
			visualL[i].setVisible(true);
			nodes[i].setSelected(true);
		}
	}
	}
	);

	JMenu helpMenu = new JMenu ("Help");
	menu.add(helpMenu);
	JMenuItem about = new JMenuItem ("About...");
	about.addActionListener ( new ActionListener() {
		public void actionPerformed(ActionEvent e)
	{
	JOptionPane.showMessageDialog(Data.this, "This application was created" + " in Summer 2005", "About", JOptionPane.INFORMATION_MESSAGE);
	}
	}
	);

	helpMenu.add(about);

	//set sertain frame preferences
	setSize (425,425);
	setResizable(false);

	//pack the frame and display it
	show();

	}

//CheckBoxHandler class is used to control the show and hide option for each node's infomation
private class CheckBoxHandler implements ItemListener {

public void itemStateChanged (ItemEvent e)
{
	for (int i=0; i<numberNodes; i++)
	{
		if (e.getSource() == nodes[i])
		{
			enegryL[i].setVisible(!toggle[i]);
			visualL[i].setVisible(!toggle[i]);
			toggle[i] = !toggle[i];
		}
	}

	// the content pane has to be redrawn so that all elements are diplayed correctly
	c.validate();
}
}


}




