// Location_Energy.java
//Written by: Maria Kazandjieva, marykaz@hotmail.com, Summer 2005

// Displays information about node location and amount of energy leff
// created 06/14/05


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.Rectangle.*;
import java.lang.*;
import java.text.*;
import javax.swing.border.*;
import java.util.Random;


public class Location_Energy extends JFrame  implements ActionListener
{
	// declare and initialize vriables

	private int numberNodes = Global.numberNodes;
	private Node[] nodes_array = Global.nodes_array;
	Node myNode;

	int[] x = new int[numberNodes];
	int[] y = new int[numberNodes];

	final int MAX = 100;
	Container c;
	JPanel dataPanel, energyPanel;
	CustomPanel displayPanel;
	JScrollPane scrollPane;
	JPanel xyPanel;
	JScrollPane xyPane;
	JLabel[] xyL = new JLabel[numberNodes];
	JFormattedTextField widthTA, heightTA;
	JLabel widthL, heightL, label1;
	JLabel[] nodeL, energyL;
	JButton goB;
	int w_unit, w;
	int h_unit, h;
	Border raisedetched = BorderFactory.createEtchedBorder(EtchedBorder.RAISED);

	public Location_Energy() {

	super("Location of nodes/ Amount of Energy Left");
	this.setLocation(325, 75);
	this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

	c = getContentPane();

	nodeL = new JLabel [numberNodes];
	energyL = new JLabel [numberNodes];

	energyPanel = new JPanel (new GridLayout (numberNodes, 2));
	energyPanel.setBorder (raisedetched);

	xyPanel = new JPanel (new GridLayout(numberNodes,1));
	xyPanel.setBorder (raisedetched);

	// initialize JLables
	for (int j=0; j<numberNodes; j++) {
		myNode = nodes_array[j];
		xyL[j] = new JLabel("Node " +(j+1)+ " at ("+ myNode.getX() + "," + myNode.getY() + ")" );
		xyPanel.add(xyL[j]);
	}

	xyPane = new JScrollPane(xyPanel);
	xyPane.setPreferredSize(new Dimension(130,420));
	c.add(xyPane, BorderLayout.EAST);

	// initialize JLabels and place them in the window frame
	for (int i =0; i<numberNodes; i++) {
		myNode = nodes_array[i];
		nodeL[i] = new JLabel ("Node " + (i+1));
		energyL[i] = new JLabel ("Energy: " + myNode.getEnergy());
		energyPanel.add(nodeL[i]);
		energyPanel.add(energyL[i]);
	}

	// We create a scroll panel that contains the energy information about nodes.
	// It is added to the window right after the plot of the nodes.

	scrollPane = new JScrollPane(energyPanel);
	scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
      scrollPane.setPreferredSize(new Dimension(200, 100));

	dataPanel = new JPanel (new BorderLayout());
	dataPanel.setBorder(raisedetched);

	// Most of the remaining code is identical to the code in Coordinates.java
	// It is used for creating the panel that plots the nodes at appropriate locations

	widthTA = new JFormattedTextField(new java.text.DecimalFormat("#####0"));
	widthTA.setColumns(5);
	widthTA.setText("100");
	heightTA = new JFormattedTextField(new java.text.DecimalFormat("#####0"));
	heightTA.setColumns(5);
	heightTA.setText("100");

	widthL = new JLabel ("Width: ");
	heightL = new JLabel ("Height: ");

	dataPanel = new JPanel();

	dataPanel.add(widthL);
	dataPanel.add(widthTA);
	dataPanel.add(heightL);
	dataPanel.add(heightTA);

	goB = new JButton ("Display nodes");
	goB.setSelected(true);
	goB.addActionListener(this);
	dataPanel.add(goB);

	c.add(dataPanel, BorderLayout.NORTH);
	c.add(scrollPane, BorderLayout.SOUTH);
	displayPanel = new CustomPanel();

	displayPanel.setBorder(raisedetched);
	c.add(displayPanel, BorderLayout.CENTER);

	//create an appropriate menu

	JMenuBar menu = new JMenuBar();
	setJMenuBar (menu);
	JMenu fileMenu = new JMenu("File");

	JMenuItem home = new JMenuItem("Selection screen");
	home.addActionListener (new ActionListener() {
	public void actionPerformed (ActionEvent e)
	{
		new ChoiceScreen();
		setVisible(false);
	}
	}
	);
	fileMenu.add(home);

	JMenuItem exit = new JMenuItem ("Exit");

	exit.addActionListener (new ActionListener() {
	public void actionPerformed (ActionEvent e)
	{
		System.exit(0);
	}
	}
	);
	fileMenu.add(exit);

	menu.add(fileMenu);

	JMenu helpMenu = new JMenu ("Help");
	menu.add(helpMenu);
	JMenuItem about = new JMenuItem ("About...");
	about.addActionListener ( new ActionListener() {
		public void actionPerformed(ActionEvent e)
	{
	JOptionPane.showMessageDialog(Location_Energy.this, "This application was created" + " in Summer 2005", "About", JOptionPane.INFORMATION_MESSAGE);
	}
	}
	);

	helpMenu.add(about);


	setSize (560,610);
	setResizable(false);
	show();
}

//this method gets the width and heiht of the area, scales down things so they fit into a 400x400
// area and calls the method that draws te graph

public void actionPerformed (ActionEvent e) {

	w = Integer.parseInt(widthTA.getText());
	h = Integer.parseInt(heightTA.getText());

	// the purpose of the variables w_unit and h_unit is scaling.
	/* in order to have all nodes fit into the 400x400 area, no matter how big the actual 	network is. Using the values that the user has entered we can scale down the network view
	while still preserving its topology */

	w_unit = 400/w;
	h_unit = 400/h;

	if (e.getSource() == goB) {
		for (int i=0; i<numberNodes; i++) {
			myNode = nodes_array[i];
			x[i] = myNode.getX();
			y[i] = myNode.getY();
		}
			displayPanel.draw(w_unit, h_unit, x, y, numberNodes);


	}
}

}